/* ------------------------------------------------------------

Problem Description
-------------------

This is a problem of building five houses. The masonry, roofing,
painting, etc. must be scheduled.  Some tasks must necessarily take
place before others and these requirements are expressed through
precedence constraints.

There are two workers and each task requires a specific worker.  The
worker has a calendar of days off that must be taken into account. The
objective is to minimize the overall completion date.

------------------------------------------------------------ */
 
using CP;

int NbHouses = ...; 
range Houses = 1..NbHouses;

{string} WorkerNames = ...;  
{string} TaskNames   = ...;

int    Duration [t in TaskNames] = ...;
string Worker   [t in TaskNames] = ...;

tuple Precedence {
  string doBefore;
  string doAfter;
};

{Precedence} Precedences = ...;

tuple Break {
  int s;
  int e;
};

{Break} Breaks[WorkerNames] = ...; 

// Declare a tuple named "Step" to define worker's 
// availability (intensity value) and date when this 
// value applies
tuple Step {
// fill in elements here  
};

/* Create a sorted tuple set such that at each point in 
time where the worker's availability changes, an instance 
of the tuple "Set" is created.

Sort the tuple "Set" by date, and use a stepfuncion 
named "calendar" to create the intensity values to be 
assigned to each WorkerName */

sorted {Step} //finish this as per instructions above
   

dvar interval itvs[h in Houses, t in TaskNames] 
  size      Duration[t]
  intensity Calendar[Worker[t]];

execute {
  cp.param.FailLimit = 10000;
}

// Add the objective function

subject to {
  forall(h in Houses) {
   // Add precendence constraints
   // Add forbidden start and end constraints
  }
  forall(w in WorkerNames)
    // Add the no overlap constraints
}
